#include <metal_stdlib>
#include <simd/simd.h>

using namespace metal;

struct buffer_t
{
    float4x4 u_View;
};

struct main0_out
{
    float4 o_fragColor [[color(0)]];
};

struct main0_in
{
    float2 v_uv0;
    float3 v_nDirWS;
};

fragment main0_out main0(main0_in in [[stage_in]], constant buffer_t& buffer, texture2d<float> _AlbedoTexture [[texture(0)]], texture2d<float> _MatCapTexture [[texture(1)]], sampler _AlbedoTextureSmplr [[sampler(0)]], sampler _MatCapTextureSmplr [[sampler(1)]])
{
    main0_out out = {};
    float2 uv = in.v_uv0;
    float3 normal = in.v_nDirWS;
    normal = normalize((buffer.u_View * float4(normal, 0.0)).xyz);
    float4 albedo = _AlbedoTexture.sample(_AlbedoTextureSmplr, uv);
    float2 matcapUV = (normal.xy * 0.5) + float2(0.5);
    matcapUV.y = 1.0 - matcapUV.y;
    float4 matcapCol = _MatCapTexture.sample(_MatCapTextureSmplr, matcapUV);
    out.o_fragColor = albedo * matcapCol;
    return out;
}

